#include "Lever.h"

using namespace Ogre;

Lever:: Lever(Ogre::SceneManager* sceneManager, NxScene* mPhysicsScene, NxPhysicsSDK* mPhysicsSDK){
	inited = false;
	leverNode = sceneManager->getRootSceneNode()->createChildSceneNode();
	leverNode->setScale(1,1,1);
	leverNode->setPosition(0,0,0);

	leverNode1 = leverNode->createChildSceneNode();
	Entity* leverEnt1 = sceneManager->createEntity("lever1", "lever.mesh");
	leverNode1->attachObject(leverEnt1);
	leverNode1->setPosition(-13.3,-0.95,52.8);

	leverNode2 = leverNode->createChildSceneNode();
	SceneNode* leverNode2b = leverNode2->createChildSceneNode();
	Entity* leverEnt2 = sceneManager->createEntity("lever0", "lever.mesh");
	leverNode2b->attachObject(leverEnt2);
	leverNode2->setPosition(9.8,-0.95,52.8);
	leverNode2b->rotate(Vector3::UNIT_Y, Radian(3.1415));

	LogManager::getSingleton().logMessage("rot1:"+StringConverter::toString(leverNode1->getOrientation().y));
	LogManager::getSingleton().logMessage("rot2:"+StringConverter::toString(leverNode2->getOrientation().y));


	Ogre::AxisAlignedBox bx1 = leverNode1->getAttachedObject(0)->getBoundingBox();
	shapeDesc1.dimensions.set(NxVec3(bx1.getSize().x*0.45, bx1.getSize().y*0.5, bx1.getSize().z*0.5));
	shapeDesc1.localPose.t.set(bx1.getSize().x*0.5-1,0,0);
	actorDesc1.shapes.pushBack(&shapeDesc1);
	actorDesc1.body = &bodyDesc1;
	actorDesc1.density = 100;
	actorDesc1.globalPose.t = NxVec3(leverNode1->getPosition().x, leverNode1->getPosition().y, leverNode1->getPosition().z);
	actor1 = mPhysicsScene->createActor(actorDesc1);
	actor1->setName("lever1");
	actor1->raiseBodyFlag(NX_BF_KINEMATIC); 

	Ogre::AxisAlignedBox bx2 = leverNode1->getAttachedObject(0)->getBoundingBox();
	shapeDesc2.dimensions.set(NxVec3(bx2.getSize().x*0.45, bx2.getSize().y*0.5, bx2.getSize().z*0.5));	
	shapeDesc2.localPose.t.set(bx2.getSize().x*0.5-1,0,0);
	actorDesc2.shapes.pushBack(&shapeDesc2);
	actorDesc2.body = &bodyDesc2;
	actorDesc2.density = 100;
	actorDesc2.globalPose.t = NxVec3(leverNode2->getPosition().x, leverNode2->getPosition().y, leverNode2->getPosition().z);
	actor2 = mPhysicsScene->createActor(actorDesc2);
	actor2->setName("lever0");
	actor2->raiseBodyFlag(NX_BF_KINEMATIC);

	inited=true;
}

void Lever::update(){
	if(inited){
		Vector3 pos = leverNode1->_getDerivedPosition();
		Quaternion orient = leverNode1->_getDerivedOrientation();
		actor1->moveGlobalPosition(NxVec3(pos.x,pos.y,pos.z));
		actor1->moveGlobalOrientation(NxQuat(NxVec3(orient.x,orient.y,orient.z),orient.w));

		Vector3 pos2 = leverNode2->_getDerivedPosition();
		Quaternion orient2 = leverNode2->getChild(0)->_getDerivedOrientation();
		actor2->moveGlobalPosition(NxVec3(pos2.x,pos2.y,pos2.z));
		actor2->moveGlobalOrientation(NxQuat(NxVec3(orient2.x,orient2.y,orient2.z),orient2.w));
	}
}

Ogre::SceneNode* Lever::getNode(){
	return leverNode;
}