#pragma once
#include "stdafx.h"
#include "Ogre.h"
#include "NxPhysics.h"
#include "Stream.h"
#include "GameController.h"
#include "TableBase.h"
#include "Ball.h"
#include "Lever.h"

class Triggerable;
class PhysicsHandler;

class PhysicsHandler : public Ogre::FrameListener{
protected:
	NxPhysicsSDK* physicsSDK;
	NxScene* physicsScene;
	Ogre::SceneManager* sceneManager;
	bool inited;
	Lever* lever;
	TableBase* tablebase;
	std::vector<Ball*> balls;
	Triggerable* triggerable;
public:
	PhysicsHandler(Ogre::SceneManager* msceneManager, GameController* _game);
	~PhysicsHandler();
	bool frameStarted(const Ogre::FrameEvent& evt);
	Lever* getLever();
	void resetBall();
	void startBall();
	void travelBall(int time);
};

class Triggerable : public NxUserTriggerReport{
protected:
	Ogre::SceneNode* booster;
	Ogre::SceneNode* springl;
	Ogre::SceneNode* springr;
	Ogre::SceneNode* hole;
	Ogre::SceneNode* buttons;
	Ogre::SceneNode* time1955;
	Ogre::SceneNode* time1985;
	NxTriangleMeshShapeDesc boosterShapeDesc;
	NxTriangleMeshShapeDesc springlShapeDesc;
	NxTriangleMeshShapeDesc springrShapeDesc;
	NxTriangleMeshShapeDesc holeShapeDesc;
	NxTriangleMeshShapeDesc time1955ShapeDesc;
	NxTriangleMeshShapeDesc time1985ShapeDesc;
	NxActorDesc boosterActorDesc;
	NxActorDesc holeActorDesc;
	NxActorDesc springlActorDesc;
	NxActorDesc springrActorDesc;
	NxActorDesc buttonsActorDesc;
	NxActorDesc time1955ActorDesc;
	NxActorDesc time1985ActorDesc;
	NxActor* boosterNx;
	NxActor* springlNx;
	NxActor* springrNx;
	NxActor* holeNx;
	NxActor* buttonsNx;
	NxActor* time1955Nx;
	NxActor* time1985Nx;
public:
	GameController* game;
	Triggerable(Ogre::SceneManager* sceneManager, NxScene* mPhysicsScene, NxPhysicsSDK* mPhysicsSDK, GameController* _game);
	void onTrigger(NxShape& triggerShape, NxShape& otherShape, NxTriggerFlag status);
};