#include "TableBase.h"
#include "NxMeshCooker.h"

using namespace Ogre;

TableBase::TableBase(Ogre::SceneManager* sceneManager, NxScene* mPhysicsScene, NxPhysicsSDK* mPhysicsSDK){
	ogreNode = sceneManager->getRootSceneNode()->createChildSceneNode();
	Entity* tableBaseEnt = sceneManager->createEntity("TableBase", "flippxtable.mesh");
	ogreNode->attachObject(tableBaseEnt);
	ogreNode->setScale(1,1,1);
	ogreNode->setPosition(0,0,0);

	NxMeshCooker::cookNxMesh(tableBaseEnt->getMesh(), UserStream("media/flippxtable.mesh.nxs", false), Vector3(1,1,1));

	shapeDesc.meshData = mPhysicsSDK->createTriangleMesh(UserStream("media/flippxtable.mesh.nxs", true));
	actorDesc.shapes.pushBack(&shapeDesc);
	actorDesc.globalPose.t = NxVec3(0,0,0);
	tableBase = mPhysicsScene->createActor(actorDesc);
	tableBase->setName("tableBase");

	coverShapeDesc.dimensions.set(NxVec3(35,0.5,65));
	coverActorDesc.shapes.pushBack(&coverShapeDesc);
	coverActorDesc.globalPose.t = NxVec3(0,2.5,0);
	coverTable = mPhysicsScene->createActor(coverActorDesc);
	coverTable->setName("cover");
}

TableBase::~TableBase(void){
}

